/*
**	Definitions for the list module.
**
**	$Header: /mip/zs/src/sys/cake/RCS/list.h,v 1.15 87/10/05 20:14:45 zs Exp $
*/

/* Modified, 19/4/88, Dave Nichols, Stanford exploration Project, Geophysics
 *			Department, Stanford University, CA. 94305, USA,
 *			dave@hanauma.stanford.edu 
 *
 * 		Change macros next and prev to upper case to avoid conflicts 
 *		with convex system include files.
 *
 */

typedef	struct	s_list
{
	Cast		l_data;
	struct	s_list	*l_prev;
	struct	s_list	*l_next;
} List;

#define	NEXT(ptr)	(ptr)->l_next
#define	PREV(ptr)	(ptr)->l_prev
#define	ldata(ptr)	(ptr)->l_data
#define	first_ptr(list)	((list)->l_next)
#define	last_ptr(list)	((list)->l_prev)
#define	first(list)	((list)->l_next->l_data)
#define	last(list)	((list)->l_prev->l_data)

#define	for_list(p, l)	for (p = (l? NEXT(l): NULL); p != l && p != NULL; p = NEXT(p))
#define	for_2list(p1, p2, l1, l2)	for \
			(p1 = (l1? NEXT(l1): NULL), p2 = (l2? NEXT(l2): NULL); \
			p1 != l1 && p1 != NULL && p2 != l2 && p2 != NULL; \
			p1 = NEXT(p1), p2 = NEXT(p2))
#define	end_list(p, l)	(p == l || p == NULL)

#define	makelist(d)		_makelist((Cast) d)
#define	addhead(l, d)		_addhead(l, (Cast) d)
#define	addtail(l, d)		_addtail(l, (Cast) d)
#define	insert_before(l, w, d)	_insert_before(l, w, (Cast) d)
#define	insert_after(l, w, d)	_insert_after(l, w, (Cast) d)

extern	List	*makelist0();
extern	List	*_makelist();
extern	List	*_addhead();
extern	List	*_addtail();
extern	List	*addlist();
extern		delete();
